#ifndef GINTENLIB_INCLUDED_SHARED_PTR_HPP_
#define GINTENLIB_INCLUDED_SHARED_PTR_HPP_

/*

      <gintenlib/shared_ptr.hpp>

  shared_ptr ： boost::shared_ptr の using 宣言

  宣言：
    using boost::shared_ptr;
    
  機能：
    単純に gintenlib 内で boost::shared_ptr を使う機会は多いので、
    予め using 宣言しておけば、いちいち boost:: と指定してやる必要が無くて楽、だけのヘッダです。
    あとは TR1 への対応をしやすいように、という意義もあります。
    その場合は互換性が失われる可能性もあるので、やるとすればメジャーバージョンアップ時でしょうが。

*/

#include <boost/shared_ptr.hpp>

namespace gintenlib
{
  using boost::shared_ptr;

}   // namespace gintenlib


#endif  // #ifndef GINTENLIB_INCLUDED_SHARED_PTR_HPP_
